
class Pile {
    private int int_array[];
    private int array_size;
    private int stack_head_index;

    private void setSize(int size) {
        array_size = size;
    }

    private int getSize() {
        return array_size;
    }

    private void setHeadIndex(int index) {
        stack_head_index = index;
    }

    private int getHeadIndex() {
        return stack_head_index;
    }

    Pile(int size) {
        int_array = new int[size];
        setSize(size);
        setHeadIndex(0);
    }

    public void empiler(int value) {
        if (!plein()) {
            int_array[stack_head_index] = value;
            stack_head_index++;
        } else {
            System.out.println("La pile est pleine");
        }
    }

    public int depiler() {
        if (!vide()) {
            stack_head_index--;
            return int_array[stack_head_index];
        } else {
            return -1;
        }
    }

    public boolean plein() {
        return (getHeadIndex() >= getSize());
    }

    public boolean vide() {
        return (getHeadIndex() == 0);
    }

    public void afficher() {
        for (int i = 0; i < getSize(); i++) {
            System.out.println("element " + i + " " + int_array[i]);
        }
    }

    public static void main(String[] args) {
        Pile stack = new Pile(5);

        stack.empiler(3);
        stack.empiler(5);
        stack.empiler(4);
        stack.empiler(7);
        stack.empiler(8);

        stack.afficher();

        System.out.println("stack index " + stack.getHeadIndex());
        System.out.println("stack head value " + stack.depiler());
        System.out.println("stack index " + stack.getHeadIndex());
        System.out.println("stack head value " + stack.depiler());
        System.out.println("stack index " + stack.getHeadIndex());
        System.out.println("stack head value " + stack.depiler());
        System.out.println("stack index " + stack.getHeadIndex());
        System.out.println("stack head value " + stack.depiler());
        System.out.println("stack index " + stack.getHeadIndex());
        System.out.println("stack head value " + stack.depiler());
        System.out.println("stack index " + stack.getHeadIndex());
        System.out.println("stack head value " + stack.depiler());
        System.out.println("stack index " + stack.getHeadIndex());

        stack.afficher();
    }
}
